#include <stdio.h>
#include <process.h>
#include <conio.h>
#include <nwcalls.h>
#include <nwncpext.h>
#include <string.h>

void Usage(void)
{
printf("Usage: nfinger username\n");
exit(1);
};

#define	FALSE	0
#define	TRUE	1

int rc;
int Attached=FALSE;
char NCPExtName[] = "FINGER SERVER";
char *ServerName="LISTER";
DWORD NCPExtID;
NWCONN_HANDLE	ConnectionHandle;
char	request[64];
WORD	requestLen;
char reply[512];
WORD rtnSize=sizeof(reply);

NW_FRAGMENT	request_frag,reply_frag;

struct queryDataStruct {
	LONG CharsEchoed;
	LONG ErrorsServicingRequests;
	LONG unused[6];
} queryData;

void main(int argc, char *argv[])
{
	puts("[nfinger 1.2  copyright (c) 1994 University of Salford]");
	if (argc!=2) Usage();

	rc=NWGetConnectionHandle(ServerName,	(NWLOCAL_MODE) 0,
						&ConnectionHandle,(NWLOCAL_SCOPE NWFAR *)NULL);

	if (rc) {
		rc=NWAttachToFileServer(ServerName,0,&ConnectionHandle);
		if (rc) {
			puts("Please attach to LISTER before running");
			exit(1);
			};
		Attached=TRUE;
		};

	rc=NWGetConnectionHandle(ServerName,(NWLOCAL_MODE) 0,
			&ConnectionHandle,(NWLOCAL_SCOPE NWFAR *)NULL);
	if (rc) {
			puts("Please attach to LISTER before running");
			exit(1);
			};

	/* we will ignore the major/minor version and revision information */
	rc = NWGetNCPExtensionInfoByName(ConnectionHandle,NCPExtName, &NCPExtID,
						NULL, NULL, NULL,	(BYTE NWFAR *)&queryData);
		if (rc)
		{
			printf("couldn't find %s! (0x%04x)\n", NCPExtName,rc);	
		if (Attached) NWDetachFromFileServer(ConnectionHandle);
		exit(1);
		}

/*
	printf("%s reports %ld characters returned, with %ld errors occuring\n",
				NCPExtName, queryData.CharsEchoed,
				queryData.ErrorsServicingRequests);
*/

	strcpy(request,argv[argc-1]);
	strcat(request,"\r\n");
	request_frag.fragAddress=request;
	request_frag.fragSize=strlen(request)+1;

	reply_frag.fragAddress=reply;
	reply_frag.fragSize=sizeof(reply);

	rc = NWFragNCPExtensionRequest(ConnectionHandle,NCPExtID, 
				1,&request_frag,1,&reply_frag);

	if (rc)	{
		printf("request to %s failed! (0x%04x)\n", NCPExtName, rc);
   	if (Attached) NWDetachFromFileServer(ConnectionHandle);
		exit(1);
		};

	puts(reply);
	if (Attached) NWDetachFromFileServer(ConnectionHandle);

	exit(0);
};
